﻿using System;

using Wisej.Web;
using Wisej.Data;


namespace TestBinding
{
    public partial class Page1 : Page
    {
        SplitContainer sc;
        TabControl tabPages;

        TextBox txtID, tabtxtID, txtName, tabtxtName;

        BindingSource _bindingSource;

        public Page1()
        {
            InitializeComponent();

            CreateBindingSource();


            CreateForm();

            BindForm();

            FillForm();
        }

        private void CreateBindingSource()
        {
            _bindingSource = new BindingSource();
            _bindingSource.DataSource = typeof(Customer);
        }

        private void CreateForm()
        {
            sc = new SplitContainer();
            sc.Orientation = Orientation.Horizontal;
            sc.Dock = DockStyle.Fill;
            this.Controls.Add(sc);

            tabPages = new TabControl();
            var tab1 = new TabPage("Tab 1");
            var tab2 = new TabPage("Tab 2");
            tabPages.TabPages.Add(tab1);
            tabPages.TabPages.Add(tab2);


            txtID = new TextBox();
            txtID.Left = 30;
            txtID.Top = 40;

            tabtxtID = new TextBox();
            tabtxtID.Left = 30;
            tabtxtID.Top = 40;

            txtName = new TextBox();
            txtName.Left = 130;
            txtName.Top = 40;

            tabtxtName = new TextBox();
            tabtxtName.Left = 90;
            tabtxtName.Top = 40;


            sc.Panel1.Controls.Add(txtID);
            sc.Panel1.Controls.Add(txtName);

            sc.Panel2.Controls.Add(tabPages);
            tab1.Controls.Add(tabtxtID);
            tab2.Controls.Add(tabtxtName);

        }

        private void BindForm()
        {
            txtID.DataBindings.Add(new Binding("Text", _bindingSource, "ID", true, DataSourceUpdateMode.OnPropertyChanged));
            txtName.DataBindings.Add(new Binding("Text", _bindingSource, "Name", true, DataSourceUpdateMode.OnPropertyChanged));

            tabtxtID.DataBindings.Add(new Binding("Text", _bindingSource, "ID", true, DataSourceUpdateMode.OnPropertyChanged));
            tabtxtName.DataBindings.Add(new Binding("Text", _bindingSource, "Name", true, DataSourceUpdateMode.OnPropertyChanged));
        }

        private void FillForm()
        {
            _bindingSource.DataSource = new Customer { ID = 1, Name = "luca" };
        }
    }

    public class Customer
    {
        public int ID { get; set; }
        public string Name { get; set; }

    }

}
